;PRO CPU02
;::::::::::::INCLEXT:::::::::::::::::::::::::

;:::::::::::: STRUCTURE :::::::::::::::::

BIT	RECORD	BIT15:1,BIT14:1,BIT13:1,BIT12:1,BIT11:1,BIT10:1,BIT9:1,BIT8:1,BIT7:1,BIT6:1,BIT5:1,BIT4:1,BIT3:1,BIT2:1,BIT1:1,BIT0:1
OSAR    RECORD OSAVR:1,OSA6:1,OSA5:1,OSA4:1,OSAZ:1,OSAY:1,OSAX:1 

;SADA PARAMETRU REGULATORU
REGULATORS STRUC
        KON_PS           DB 6 DUP (?)   ;PREPINACE X

        KON_X_KS         DB 6 DUP (?) 	;RYCHLOSTNI VAZBA "X" K2,K3,K4,K5,K7
        KON_Y_KS         DB 6 DUP (?) 	;RYCHLOSTNI VAZBA "Y" K2,K3,K4,K5,K7
        KON_Z_KS         DB 6 DUP (?) 	;RYCHLOSTNI VAZBA "Z" K2,K3,K4,K5,K7
        KON_4_KS         DB 6 DUP (?) 	;RYCHLOSTNI VAZBA "4" K2,K3,K4,K5,K7
        KON_5_KS         DB 6 DUP (?) 	;RYCHLOSTNI VAZBA "5" K2,K3,K4,K5,K7
        KON_6_KS         DB 6 DUP (?) 	;RYCHLOSTNI VAZBA "6" K2,K3,K4,K5,K7

        B_LIMIT_XS      DW   ?	  ;LIMIT PRO RAZENI INTEGRALU
        B_LIMIT_YS      DW   ?	  ;LIMIT PRO RAZENI INTEGRALU
        B_LIMIT_ZS      DW   ?	  ;LIMIT PRO RAZENI INTEGRALU
        B_LIMIT_4S      DW   ?	  ;LIMIT PRO RAZENI INTEGRALU
        B_LIMIT_5S      DW   ?	  ;LIMIT PRO RAZENI INTEGRALU
        B_LIMIT_6S      DW   ?	  ;LIMIT PRO RAZENI INTEGRALU

        B_IRCKON2_VRS   DW      ?   ;TANGENS      ;**
        B_IRCKON2_XS    DW 	?   ;TANGENS      ;**
        B_IRCKON2_YS    DW 	?   ;TANGENS      ;**
        B_IRCKON2_ZS    DW 	?   ;TANGENS      ;**
        B_IRCKON2_4S    DW 	?   ;TANGENS      ;**
        B_IRCKON2_5S    DW 	?   ;TANGENS      ;**
        B_IRCKON2_6S    DW 	?   ;TANGENS      ;**

        B_ROTACI2_VRS   DW	?   ;ROTACE       ;**
        B_ROTACI2_XS    DW	?   ;ROTACE       ;**
        B_ROTACI2_YS    DW	?   ;ROTACE       ;**
        B_ROTACI2_ZS    DW	?   ;ROTACE       ;**
        B_ROTACI2_4S    DW	?   ;ROTACE       ;**
        B_ROTACI2_5S    DW	?   ;ROTACE       ;**
        B_ROTACI2_6S    DW	?   ;ROTACE       ;**

REGULATORS ENDS

REG_KONST STRUC
        ??K2S             DB      ?
        ??K3S             DB      ?
        ??K4S             DB      ?
        ??K5S             DB      ?
        ??K6S             DB      ?
        ??K7S             DB      ?
REG_KONST ENDS

REG_KONST2 STRUC
        ??OXS             DB      ?
        ??OYS             DB      ?
        ??OZS             DB      ?
        ??O4S             DB      ?
        ??O5S             DB      ?
        ??O6S             DB      ?
REG_KONST2 ENDS



;:::::::::::: MACRO :::::::::::::::::


;logicky posun CX,AX doleva
LSLL    MACRO
	SAL	AX,1
	RCL	CX,1
ENDM
	
;logicky posun CX,AX doprava
LSR     MACRO
	SHR	CX,1
	RCR	AX,1
ENDM

;aritmeticky posun CX,AX doleva se zachovanim znamenka
ASL     MACRO
	SAL	AX,1
	RCL	CX,1
	RCL	CX,1
	ROR	CX,1
ENDM
	
;aritmeticky posun CX,AX doprava se zachovanim znamenka
ASR     MACRO
	SAR	CX,1
	RCR	AX,1
ENDM	

;aritmeticky posun CX,AX doleva se zachovanim znamenka
;pocet v DL
ASLN    MACRO   NNN
        LOCAL ASLN0000
	MOV	DL,NNN
ASLN0000:
	SAL	AX,1
	RCL	CX,1
	RCL	CX,1
	ROR	CX,1
	DEC	DL
	JNZ	ASLN0000
ENDM
	
;aritmeticky posun CX,AX doprava se zachovanim znamenka
;pocet v DL
ASRN    MACRO   NNN
        LOCAL ASRN0000
	MOV	DL,NNN
ASRN0000:
	SAR	CX,1
	RCR	AX,1
	DEC	DL
	JNZ	ASRN0000
ENDM

;logicky posun CX,AX doleva - pocet v DL
LSLN    MACRO   NNN
        LOCAL   LSLN0000
	MOV	DL,NNN
LSLN0000:
	SAL	AX,1
	RCL	CX,1
	DEC	DL
	JNZ	LSLN0000
ENDM
	
;logicky posun CX,AX doprava - pocet v DL
LSRN    MACRO   NNN
        LOCAL LSRN0000
	MOV	DL,NNN
LSRN0000:
	SHR	CX,1
	RCR	AX,1
	DEC	DL
	JNZ	LSRN0000
ENDM	

;rotace spojenych registru CX,AX doprava
RRR     MACRO  
        LOCAL   RRR0000
	TEST	AL,MASK BIT0
	JZ	RRR0000
	STC
RRR0000: RCR	CX,1
	RCR	AX,1
ENDM

;rotace spojenych registru CX,AX doleva
RRL     MACRO   
        LOCAL RRL0000
	TEST	CH,MASK BIT7
	JZ	RRL0000
	STC
RRL0000: RCL	AX,1
	RCL	CX,1
ENDM

;2' DOPLNEK DWORD   VSTUP I VYSTUP AX,CX
DCM     MACRO
        LOCAL S?DCMA
	NOT	CX
	NEG	AX
	JNZ	S?DCMA
	INC	CX
S?DCMA:
ENDM

;ABSOLUTNI HODNOTA DWORD   VSTUP I VYSTUP AX,CX
DAB     MACRO   
        LOCAL S?DABA
	TEST	CH,80H
	JZ	S?DABA
	NOT	CX
	NEG	AX
	JNZ	S?DABA
	INC	CX
S?DABA:
ENDM

;VYSTUP NA PERIFERIE
OUTM    MACRO   PORT
        MOV     DX,PORT
        OUT     DX,AL
ENDM        

;VSTUP Z PERIFERIE
INM     MACRO   PORT
        MOV     DX,PORT
        IN      AL,DX
ENDM        

	
;PREVOD NA ANALOGOVE NAPETI PRO SU02
ANAL    MACRO
        LOCAL S?ANAL
	OR	AX,AX
	JNS	S?ANAL
	NEG	AX
	OR	AH,MASK BIT7
S?ANAL:
ENDM

;UZIVATELSKA MAKRA
CMPCX   MACRO
        CMP CX,CS:[BX]
ENDM        

CMPCX4  MACRO
        CMP CX,CS:[BX]+4
ENDM        

MOVCX   MACRO
        MOV CX,CS:[BX]
ENDM        

MOVCLX  MACRO
        MOV CL,CS:[BX]
ENDM        

MOVDICX MACRO
        MOV DS:[DI],CX
ENDM        

;:::::::::::: EXTERNAL :::::::::::::::::

;INCLUDE PRO EXTERNAL SYMBOLY V JAZYCE PIS806
;PRO TVORBU PROGRAMOVATELNEHO INTERFEJSU STROJE


EXTRN BUKON90:WORD,BUKON91:WORD,BUKON92:WORD,BUKON93:WORD,BUKON94:WORD
EXTRN BUKON65:WORD,BUKON68:WORD
_?BUKON90 = 2
_?BUKON91 = 2
_?BUKON92 = 2
_?BUKON93 = 2
_?BUKON94 = 2
_?BUKON65 = 2
_?BUKON68 = 2
EXTRN  BUKON170:WORD

EXTRN VRETENO_X:BYTE,VRETENO_Y:BYTE,VRETENO_Z:BYTE
EXTRN VRETENO_4:BYTE,VRETENO_5:BYTE,VRETENO_6:BYTE
_?VRETENO_X = 1
_?VRETENO_Y = 1
_?VRETENO_Z = 1
_?VRETENO_4 = 1
_?VRETENO_5 = 1
_?VRETENO_6 = 1

EXTRN DOJIZ_POLOH:WORD,V?MIN:WORD
_?DOJIZ_POLOH = 2
_?V?MIN = 2

EXTRN ZMENA_SCPI:BYTE

EXTRN B_POL:DWORD,B_INK:DWORD,DIFCIT_X:DWORD,KI_PI:WORD

EXTRN B_IRCKON_X:WORD,B_ROTACI_X:WORD,B_ZBYIRC_X:WORD
EXTRN B_IRCVRE_X:WORD,B_ROTVRE_X:WORD
EXTRN B_IRCKON_UX:WORD,B_ROTACI_UX:WORD
EXTRN BUKON60_R:BYTE,BUKON60:DWORD

EXTRN AKTUAL_PORT_VR:DWORD
EXTRN AKTUAL_PORT_VRAX:DWORD

EXTRN ?PAMCD:BYTE,?PAMCD_SI:WORD
EXTRN PLC_STACK:WORD,PLC_STACK_END:WORD,POINT_STACK:WORD,COUNT_STACK:BYTE

EXTRN VYSOVERS:WORD
_?VYSOVERS = 2

EXTRN BUN_JOGMIK:BYTE
_?BUN_JOGMIK = 1

EXTRN   B_ZBYIRC2_X:WORD,B_ZBYIRC2_Y:WORD,B_ZBYIRC2_Z:WORD
EXTRN   B_ZBYIRC2_4:WORD,B_ZBYIRC2_5:WORD,B_ZBYIRC2_6:WORD
EXTRN   RTM_TEST:BYTE

;SADY PARAMETRU REGULATORU
EXTRN   REG_AKTUAL:REGULATORS
EXTRN   REGULATOR_SADA1:REGULATORS
EXTRN   REGULATOR_SADA2:REGULATORS
EXTRN   REGULATOR_SADA3:REGULATORS
EXTRN   REGULATOR_SADA4:REGULATORS

EXTRN   TAB_BREAK:BYTE
EXTRN   POCET_BREAK:BYTE
EXTRN   FL_50PROC_PLC:BYTE
EXTRN   FL_ANALOG_G96:BYTE
EXTRN   HALT_STATUS_MEM:BYTE
_?FL_50PROC_PLC = 1

;MULTIPLEXOVANE VSTUPY
EXTRN   TAB_MUX_PORT_1:BYTE,TAB_MUX_PORT_2:BYTE
EXTRN   TAB_MUX_1:BYTE,TAB_MUX_2:BYTE
EXTRN   TAB_MUX_PORT_FAST:BYTE

;  V Y S T U P Y    V    P A N E L U
;BZH17 = TLOUT  ...... NA DESCE TLACITEK  (ADDRPORT_TLAC+1)
;BZH18 = P1OUT  ...... NA DESCE VST02     (ADDRPORT_IO1)
;BZH19 = P2OUT  ...... NA DESCE VST02     (ADDRPORT_IO1+1)

;  V S T U P Y    V    P A N E L U
;TLIN  .... NA DESCE TLACITEK  (ADDRPORT_TLAC+1)
;P1IN  .... NA DESCE VST02     (ADDRPORT_IO1)
;P2IN  .... NA DESCE VST02     (ADDRPORT_IO1+1)
;P3IN  .... NA DESCE VST02     (ADDRPORT_IO1+2)
;P4IN  .... NA DESCE VST02     (ADDRPORT_IO1+3)
EXTRN P1IN:BYTE,P2IN:BYTE,P3IN:BYTE
EXTRN P4IN:BYTE,TLIN:BYTE
_?P1IN = 1
_?P2IN = 1
_?P3IN = 1
_?P4IN = 1
_?TLIN = 1

;  P A N E L   S T R O J E
EXTRN PANEL_STROJE:BYTE
_?PANEL_STROJE = 1

EXTRN   REZIMPI:BYTE
_?REZIMPI = 1

EXTRN   BUF_POTENC:DWORD,KROK_TOC_EXT:WORD
_?KROK_TOC_EXT = 2

EXTRN   LABEL_MEM:BYTE,BZH08RTM:BYTE
_?LABEL_MEM = 1
_?BZH08RTM = 1

